// assembler module
module fuun;
import std.conv;
import std.string;
import std.c.stdlib;

//----------------------------------------------------------------------------
// very primitive utilities
//----------------------------------------------------------------------------

int fromHex(string s)
{
	char* dummy;
	return strtol(s.toStringz(), &dummy, 16);
}

string unnat_impl(int n)  // convert to I/C encoding
{
	string s;
	for(;n;n/=2)
		s ~= (n%2 ? 'C' : 'I');
	return s;
}

string enc(bool b) { return b ? "P" : "F"; }
string enc(int  n) { return unnat_impl(n)~"P"; }

string quote( string expr )
{
	string s;
	foreach(c; expr)
		if(c=='I') s~= 'C';
		else if(c=='C') s~= 'F';
		else if(c=='F') s~= 'P';
		else if(c=='P') s~= "IC";
	return s;
}

//----------------------------------------------------------------------------
// pattern/template construction
//----------------------------------------------------------------------------

string p_group( string s )   { return "IIP" ~ s ~ "IIC"; }
string p_skip( int n )       { return "IP" ~  enc(n); }
string p_seek( string s )    { return "IFF" ~ quote(s); }
string p_check( string s )   { return quote(s); }
string p_end()               { return "IIC"; }

string t_str(string s)       { return quote(s); }
string t_ref(int n, int l=0) { return "IP" ~ enc(l) ~ enc(n); }
string t_len(int n)          { return "IIP" ~ enc(n); }
string t_end()               { return "IIC"; }

//----------------------------------------------------------------------------
// higher utils
//----------------------------------------------------------------------------

string funcall( int off, int siz )
{
	return
		p_group(p_seek("IFPICFPPCCC") ~ p_group(p_seek("IFPICFPPCCC"))) ~ p_end ~
		t_ref(0) ~ t_str(enc(off)) ~ t_str(enc(siz)) ~ t_ref(1) ~ t_end;
}

string setPage( int page )
{
	string p = unnat_impl(page);
	char[] t = p.dup; t[]='I';
	return
		p_group(p_seek("IFPCFFP")) ~ p_check(t) ~ p_end ~
		t_ref(0) ~ t_str(p) ~ t_end;
}

string ret( int funlen, int offset=10 )
{
	for(int retlen=0 ;; ++retlen)
	{
		auto r =
			p_skip(funlen-retlen-offset) ~ p_group(p_skip(7509409))
			~ p_group(p_skip(24)) ~ p_group(p_skip(24)) ~ p_end
			~ t_str("IIPIP") ~ t_ref(1) ~ t_str("IIPIP") ~ t_ref(2)
			~ t_str("IICIICIICIPPPIPPCPIIC") ~ t_ref(0) ~ t_end;
		if( r.length == retlen )
			return r;
		assert( retlen < r.length );
	}
}
