//----------------------------------------------------------------------------
// PNG to Text converter
//   Usage:
//     p2d in.png > out.txt
//----------------------------------------------------------------------------

import png;
import std.file;
import std.cstream;

struct Px
{
	ubyte R;
	ubyte G;
	ubyte B;
	ubyte A;
}

Px[][] loadPNG( string filename )
{
	ubyte[] img;
	Info info = png.decode32(img, cast(ubyte[])std.file.read(filename));

	Px[][] p;
	for(int y=0; y<info.h; ++y)
		p ~= (cast(Px*)(img.ptr + Px.sizeof*info.w))[0 .. info.w];
	return p;
}

string ___="PIPIIIC";
string R__="PIPIIIP";
string _G_="PIPIICC";
string RG_="PIPIICF";
string __B="PIPIICP";
string R_B="PIPIIFC";
string _GB="PIPIIFF";
string RGB="PIPIIPC";
string EMP="PIIPICP";

void main( string[] argv )
{
	if( argv.length <= 1 )
	{
		derr.writefln();
		derr.writefln("Usage:");
		derr.writefln("  p2t in.png > out.txt");
	}

	auto img = loadPNG( argv[1] );

	for(int y=0; y<img.length; ++y)
		for(int x=0; x<img[y].length; ++x)
			dout.writefln("%d %d %d %d", img[y][x].R, img[y][x].G, img[y][x].B, img[y][x].A );
}
